<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Exemple de classe avec des éléments à parcourir
 *
 * Utilise l'interface Iterator pour parcourir un objet
 * 
 */
class ExempleData implements Iterator
{

	private $aCollection = [];// les éléments à parcourir - dans des applications complexes, c'est une collection d'objets
    private $nIndex = 0;// la position dans le tableau, le numéro de l'élément courant


	/**
	 * constructeur vide
	 */
	public function __construct()
	{ }


	/**
	 * Ajoute un élément dans la liste
	 * 
	 * @param  
	 * @return [type]                       [description]
	 */
	public function add($oData)
	{
		$this->aCollection[] = $oData;
	}


	/**
	 * Supprime un élément de la collection
	 * 
	 * @param  
	 * @return [type]                       [description]
	 */
	public function remove($oData)
	{
		$sKey = array_search($oData, $this->aCollection, true);
		
		if ($sKey)
		{
            unset($this->aCollection[$sKey]);// supprime l'élément recherché

            // déplace les éléments suivants à partir de l'emplacement vide
            $this->setKey($sKey);
            $this->next();// élément suivant

            while( $this->valid() )
            {
                $this->aCollection[$sKey] = $this->current();
                $sKey++;
                $this->next();// élément suivant
            }

            // supprime le dernier élément de la collection (déplacé à la position précédente)
            unset($this->aCollection[$sKey]);
        }	
        else
            echo "élément non trouve : ".$oData;

		// complétez cette méthode, en ajoutant un traitement de la collection 
		// pour supprimer les espaces vides créés par les suppressions
	}


	/**
	 * Renvoie l'élément courant.
	 * 
	 * @return [type] [description]
	 */
	public function current()
    {
        return $this->aCollection[$this->nIndex];
    }


    /**
     * Passe à l'élément suivant dans la collection
     * 
     * @return function [description]
     */
    public function next()
    {
        $this->nIndex ++;
    }


    /**
     * Renvoie la position actuelle, la clé
     * 
     * @return [type] [description]
     */
    public function key()
    {
        return $this->nIndex;
    }


    /**
     * Définit la position actuelle, la clé
     * 
     * @return renvoie l'élément positionné sur cette clé
     */
    public function setKey( $sValue )
    {
        $this->nIndex = $sValue;
        return $this->current();
    }



    /**
     * Vérifie l'existence de l'élément courant,
     * à partirt de la clé courante.
     * 
     * @return [type] [description]
     */
    public function valid()
    {
        return isset( $this->aCollection[$this->key()] );
    }


    /**
     * Retour au début de la collection, au premier élément
     * 
     * @return [type] [description]
     */
    public function rewind()
    {
        $this->nIndex = 0;
    }


    /**
     * Inverse l'ordre des éléments dans la collection
     * 
     * @return [type] [description]
     */
    public function reverse()
    {
        $this->aCollection = array_reverse($this->aCollection);
        $this->rewind();
    }


}

?>